#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/uio.h>
#include <net/if.h>

#include <linux/can.h>
#include <linux/can/bcm.h>

#include "../can_config.h"

#define U64_DATA(p) (*(unsigned long long*)(p)->data)

int main(int argc, char **argv)
{
        int s;
        struct sockaddr_can addr;
        struct ifreq ifr;

        struct {
                struct bcm_msg_head msg_head;
                struct can_frame frame[4];
        } msg;

        if ((s = socket(PF_CAN, SOCK_DGRAM, CAN_BCM)) < 0) {
                perror("socket");
                return 1;
        }

        addr.can_family = PF_CAN;
        strcpy(ifr.ifr_name, "vcan0");
        ioctl(s, SIOCGIFINDEX, &ifr);
        addr.can_ifindex = ifr.ifr_ifindex;

        if (connect(s, (struct sockaddr *)&addr, sizeof(addr)) < 0) {
                perror("connect");
                return 1;
        }

        msg.msg_head.opcode  = TX_SETUP;
        msg.msg_head.can_id  = 0x42;
        msg.msg_head.flags   = SETTIMER|STARTTIMER;
        msg.msg_head.nframes = 1;
        msg.msg_head.count = 999999;
        msg.msg_head.ival1.tv_sec = 1;
        msg.msg_head.ival1.tv_usec = 0;
        msg.msg_head.ival2.tv_sec = 0;
        msg.msg_head.ival2.tv_usec = 0;
        msg.frame[0].can_id    = 0x42;
        msg.frame[0].can_dlc   = 8;
        U64_DATA(&msg.frame[0]) = (__u64) 0xdeadbeefdeadbeefULL;

        if (write(s, &msg, sizeof(msg)) < 0)
                perror("write");

        printf("Press any key to stop the cycle ...\n");

        getchar();

        msg.msg_head.opcode  = TX_SETUP;
        msg.msg_head.can_id  = 0x42;
        msg.msg_head.flags   = SETTIMER|STARTTIMER;
        msg.msg_head.nframes = 1;
        msg.msg_head.count = 0;
        msg.msg_head.ival1.tv_sec = 0;
        msg.msg_head.ival1.tv_usec = 0;
        msg.msg_head.ival2.tv_sec = 0;
        msg.msg_head.ival2.tv_usec = 0;
        msg.frame[0].can_id    = 0x42;
        msg.frame[0].can_dlc   = 8;
        U64_DATA(&msg.frame[0]) = (__u64) 0xdeadbeefdeadbeefULL;

        if (write(s, &msg, sizeof(msg)) < 0)
                perror("write");

        printf("Press any key to close the socket ...\n");

        getchar();

        close(s);

        printf("Press any key to end the program ...\n");

        getchar();

    return 0;
}
